//
// Analog to Digital Conversion and Send UART(9600bps) via GP2
//                                    2011.3.27 by Tomono
//
#include <pic.h>
__CONFIG(OSC_8MHZ & MCPUEN & MCLREN & WDTDIS & UNPROTECT);
// TEST CHIP's OSCCAL=0xC20

// send character in 9600bps
#define TXD GP2
void putc(unsigned char c){
	int s; // shift register
	unsigned char i;
	volatile unsigned char j;
	s = ((int) c) << 2;
	s = s | 0xfc01;  // 1111_11xx_xxxx_xx01
	for(i=0;i<11;i++){
		if(s & 1){
			TXD = 1;
		} else {
			TXD = 0;
		}
		s = s>>1;
		for(j=0;j<15;j++);
	}
}

void puthex(unsigned char v){
	unsigned char c;
	c = (v >> 4) & 0x0f;
	if(c > 9){ c += ('A' - '9' - 1) ;};
	putc(c + '0');
	c =  v       & 0x0f;
	if(c > 9){ c += ('A' - '9' - 1) ;};
	putc(c + '0');
}

unsigned char getadc0(void){
	ADCON0 = 0xc1;			// SELECT CH0(AN0)
	for(char j=0;j<5;j++);
	ADCON0 = 0xc3;			// ADC CH0(AN0) START
	while(ADCON0 & 0x02);	// wait for finish of conversion
	return(ADRES);
}

unsigned char getadc1(void){
	ADCON0 = 0xc5;			// SELECT CH1(AN1)
	for(char j=0;j<5;j++);
	ADCON0 = 0xc7;			// ADC CH1(AN1) START
	while(ADCON0 & 0x02);	// wait for finish of conversion
	return(ADRES);
}

unsigned char getvref(void){
	ADCON0 = 0xc9;			// SELECT Vref
	for(char j=0;j<5;j++);
	ADCON0 = 0xcb;			// ADC Vref START
	while(ADCON0 & 0x02);	// wait for finish of conversion
	return(ADRES);
}

void main(void){
	char i;
	TRISGPIO = 0xfb;	// GP2=OUT
	OPTION = 0x07;		// Prescaler
	ADCON0 = 0xc1;		// ADC enable
	while(1){
		puthex(getvref()); putc(' ');
		puthex(getadc0()); putc(' ');
		puthex(getadc1());
		putc(0x0d);
		putc(0x0a);
	}
}


	